<?php
App::uses('BuzzWaiversAppModel', 'BuzzWaivers.Model');
App::uses('String', 'Utility');
/**
 * Participant Model
 *
 */
class Participant extends BuzzWaiversAppModel {

	public $virtualFields = array(
	    'name' => '
			CASE WHEN (Participant.adult_first_name IS NOT NULL AND Participant.adult_first_name != \'\') THEN
				CONCAT("Adult: ", Participant.adult_first_name, " ", Participant.adult_first_name, " Child: ", Participant.first_name, " ", Participant.last_name)
			ELSE
				CONCAT(Participant.first_name, " ", Participant.last_name)
			END
		'
	);

	public $hasAndBelongsToMany = array(
		'Condition' => array(
			'className' => 'BuzzWaivers.Condition',
			'joinTable' => 'buzz_waivers_participant_conditions'
		)
	);

/**
 * Primary key field
 *
 * @var string
 */
	public $primaryKey = 'id';

/**
 * Display field
 *
 * @var string
 */
	public $displayField = 'email';

	public function beforeSave($options = array()) {
		if (empty($this->data['Participant']['id']) && empty($this->id)) {
			$this->data['Participant']['id'] = String::uuid();
		}

		return parent::beforeSave($options);

	}

}
